summaryrefslogtreecommitdiff
path: root/auto/bin
diff options
context:
space:
mode:
Diffstat (limited to 'auto/bin')
-rwxr-xr-xauto/bin/filter_gl_ext.sh510
-rwxr-xr-xauto/bin/filter_gles_ext.sh19
-rwxr-xr-xauto/bin/filter_spec.py38
-rwxr-xr-xauto/bin/make.pl209
-rwxr-xr-xauto/bin/make_def_fun.pl35
-rwxr-xr-xauto/bin/make_def_var.pl31
-rwxr-xr-xauto/bin/make_header.pl71
-rwxr-xr-xauto/bin/make_html.pl55
-rwxr-xr-xauto/bin/make_info.pl59
-rwxr-xr-xauto/bin/make_info_list.pl47
-rwxr-xr-xauto/bin/make_init.pl54
-rwxr-xr-xauto/bin/make_list.pl66
-rwxr-xr-xauto/bin/make_str.pl53
-rwxr-xr-xauto/bin/make_struct_fun.pl36
-rwxr-xr-xauto/bin/make_struct_var.pl31
-rwxr-xr-xauto/bin/parse_spec.pl378
-rwxr-xr-xauto/bin/update_ext.sh25
17 files changed, 1717 insertions, 0 deletions
diff --git a/auto/bin/filter_gl_ext.sh b/auto/bin/filter_gl_ext.sh
new file mode 100755
index 0000000..72fde80
--- /dev/null
+++ b/auto/bin/filter_gl_ext.sh
@@ -0,0 +1,510 @@
+#!/bin/bash
+##
+## Copyright (C) 2002-2008, Marcelo E. Magallon <mmagallo[]debian org>
+## Copyright (C) 2002-2008, Milan Ikits <milan ikits[]ieee org>
+##
+## This program is distributed under the terms and conditions of the GNU
+## General Public License Version 2 as published by the Free Software
+## Foundation or, at your option, any later version.
+##
+## Parameters:
+##
+## $1: Extensions directory
+
+set -e
+
+# fix GL_NV_texture_compression_vtc
+ grep -v EXT $1/GL_NV_texture_compression_vtc > tmp
+ mv tmp $1/GL_NV_texture_compression_vtc
+
+# remove duplicates from GL_ARB_vertex_program and GL_ARB_fragment_program
+ grep -v -F -f $1/GL_ARB_vertex_program $1/GL_ARB_fragment_program > tmp
+ mv tmp $1/GL_ARB_fragment_program
+
+# remove duplicates from GLX_EXT_visual_rating and GLX_EXT_visual_info
+ grep -v -F -f $1/GLX_EXT_visual_info $1/GLX_EXT_visual_rating > tmp
+ mv tmp $1/GLX_EXT_visual_rating
+
+# GL_EXT_draw_buffers2 and GL_EXT_transform_feedback both define glGetBooleanIndexedvEXT but with different parameter names
+ grep -v glGetBooleanIndexedvEXT $1/GL_EXT_transform_feedback > tmp
+ mv tmp $1/GL_EXT_transform_feedback
+
+# GL_EXT_draw_buffers2 and GL_EXT_transform_feedback both define glGetIntegerIndexedvEXT but with different parameter names
+ grep -v glGetIntegerIndexedvEXT $1/GL_EXT_transform_feedback > tmp
+ mv tmp $1/GL_EXT_transform_feedback
+
+# remove duplicates from GL_NV_video_capture and GLX_NV_video_capture
+ grep -v glX $1/GL_NV_video_capture > tmp
+ mv tmp $1/GL_NV_video_capture
+
+# add missing functions to GL_NV_video_capture
+ cat >> $1/GL_NV_video_capture <<EOT
+ void glGetVideoCaptureStreamivNV (GLuint video_capture_slot, GLuint stream, GLenum pname, GLint* params)
+ void glGetVideoCaptureStreamfvNV (GLuint video_capture_slot, GLuint stream, GLenum pname, GLfloat* params)
+ void glGetVideoCaptureStreamdvNV (GLuint video_capture_slot, GLuint stream, GLenum pname, GLdouble* params)
+ void glVideoCaptureStreamParameterivNV (GLuint video_capture_slot, GLuint stream, GLenum pname, const GLint* params)
+ void glVideoCaptureStreamParameterfvNV (GLuint video_capture_slot, GLuint stream, GLenum pname, const GLfloat* params)
+ void glVideoCaptureStreamParameterdvNV (GLuint video_capture_slot, GLuint stream, GLenum pname, const GLdouble* params)
+EOT
+
+# fix WGL_NV_video_capture
+ cat >> $1/WGL_NV_video_capture <<EOT
+ DECLARE_HANDLE(HVIDEOINPUTDEVICENV);
+EOT
+
+# fix GLX_NV_video_capture
+ cat >> $1/GLX_NV_video_capture <<EOT
+ typedef XID GLXVideoCaptureDeviceNV
+EOT
+
+# remove duplicates from GL_NV_present_video and GLX_NV_present_video
+ grep -v -F -f $1/GLX_NV_present_video $1/GL_NV_present_video > tmp
+ mv tmp $1/GL_NV_present_video
+
+# fix WGL_NV_present_video
+ cat >> $1/WGL_NV_present_video <<EOT
+ DECLARE_HANDLE(HVIDEOOUTPUTDEVICENV);
+EOT
+
+# fix WGL_NV_video_output
+ cat >> $1/WGL_NV_video_output <<EOT
+ DECLARE_HANDLE(HPVIDEODEV);
+EOT
+
+# fix GL_NV_occlusion_query and GL_HP_occlusion_test
+ grep -v '_HP' $1/GL_NV_occlusion_query > tmp
+ mv tmp $1/GL_NV_occlusion_query
+ perl -e's/OCCLUSION_TEST_HP.*/OCCLUSION_TEST_HP 0x8165/' -pi \
+ $1/GL_HP_occlusion_test
+ perl -e's/OCCLUSION_TEST_RESULT_HP.*/OCCLUSION_TEST_RESULT_HP 0x8166/' -pi \
+ $1/GL_HP_occlusion_test
+
+# add deprecated constants to GL_ATI_fragment_shader
+ cat >> $1/GL_ATI_fragment_shader <<EOT
+ GL_NUM_FRAGMENT_REGISTERS_ATI 0x896E
+ GL_NUM_FRAGMENT_CONSTANTS_ATI 0x896F
+ GL_NUM_PASSES_ATI 0x8970
+ GL_NUM_INSTRUCTIONS_PER_PASS_ATI 0x8971
+ GL_NUM_INSTRUCTIONS_TOTAL_ATI 0x8972
+ GL_NUM_INPUT_INTERPOLATOR_COMPONENTS_ATI 0x8973
+ GL_NUM_LOOPBACK_COMPONENTS_ATI 0x8974
+ GL_COLOR_ALPHA_PAIRING_ATI 0x8975
+ GL_SWIZZLE_STRQ_ATI 0x897A
+ GL_SWIZZLE_STRQ_DQ_ATI 0x897B
+EOT
+
+# add deprecated constants to GL_NV_texture_shader
+ cat >> $1/GL_NV_texture_shader <<EOT
+ GL_OFFSET_TEXTURE_2D_MATRIX_NV 0x86E1
+ GL_OFFSET_TEXTURE_2D_BIAS_NV 0x86E3
+ GL_OFFSET_TEXTURE_2D_SCALE_NV 0x86E2
+EOT
+
+# fix WGL_ATI_pixel_format_float
+ cat >> $1/WGL_ATI_pixel_format_float <<EOT
+ GL_RGBA_FLOAT_MODE_ATI 0x8820
+ GL_COLOR_CLEAR_UNCLAMPED_VALUE_ATI 0x8835
+EOT
+
+# fix WGL_ARB_make_current_read
+ cat >> $1/WGL_ARB_make_current_read <<EOT
+ ERROR_INVALID_PIXEL_TYPE_ARB 0x2043
+ ERROR_INCOMPATIBLE_DEVICE_CONTEXTS_ARB 0x2054
+EOT
+
+# fix WGL_EXT_make_current_read
+ cat >> $1/WGL_EXT_make_current_read <<EOT
+ ERROR_INVALID_PIXEL_TYPE_EXT 0x2043
+EOT
+
+# add typedefs to GL_ARB_vertex_buffer_object; (from personal communication
+# with Marco Fabbricatore).
+#
+# Rationale. The spec says:
+#
+# "Both types are defined as signed integers large enough to contain
+# any pointer value [...] The idea of making these types unsigned was
+# considered, but was ultimately rejected ..."
+ cat >> $1/GL_ARB_vertex_buffer_object <<EOT
+ typedef ptrdiff_t GLsizeiptrARB
+ typedef ptrdiff_t GLintptrARB
+EOT
+
+# add typedefs to GLX_EXT_import_context
+ cat >> $1/GLX_EXT_import_context <<EOT
+ typedef XID GLXContextID
+EOT
+
+# add tokens to GLX_OML_swap_method
+ cat >> $1/GLX_OML_swap_method <<EOT
+ GLX_SWAP_EXCHANGE_OML 0x8061
+ GLX_SWAP_COPY_OML 0x8062
+ GLX_SWAP_UNDEFINED_OML 0x8063
+EOT
+
+# add typedefs to GLX_SGIX_fbconfig
+ cat >> $1/GLX_SGIX_fbconfig <<EOT
+ typedef XID GLXFBConfigIDSGIX
+ typedef struct __GLXFBConfigRec *GLXFBConfigSGIX
+EOT
+
+# add typedefs to GLX_SGIX_pbuffer
+ cat >> $1/GLX_SGIX_pbuffer <<EOT
+ typedef XID GLXPbufferSGIX
+ typedef struct { int type; unsigned long serial; Bool send_event; Display *display; GLXDrawable drawable; int event_type; int draw_type; unsigned int mask; int x, y; int width, height; int count; } GLXBufferClobberEventSGIX
+EOT
+
+# add typedef to GL_NV_half_float
+ cat >> $1/GL_NV_half_float <<EOT
+ typedef unsigned short GLhalf
+EOT
+
+# add handle to WGL_ARB_pbuffer
+ cat >> $1/WGL_ARB_pbuffer <<EOT
+ DECLARE_HANDLE(HPBUFFERARB);
+EOT
+
+# add handle to WGL_EXT_pbuffer
+ cat >> $1/WGL_EXT_pbuffer <<EOT
+ DECLARE_HANDLE(HPBUFFEREXT);
+EOT
+
+# get rid of GL_SUN_multi_draw_arrays
+ rm -f $1/GL_SUN_multi_draw_arrays
+
+# change variable names in GL_ARB_vertex_shader
+ perl -e 's/v0/x/g' -pi $1/GL_ARB_vertex_shader
+ perl -e 's/v1/y/g' -pi $1/GL_ARB_vertex_shader
+ perl -e 's/v2/z/g' -pi $1/GL_ARB_vertex_shader
+ perl -e 's/v3/w/g' -pi $1/GL_ARB_vertex_shader
+
+# remove triplicates in GL_ARB_shader_objects, GL_ARB_fragment_shader,
+# and GL_ARB_vertex_shader
+ grep -v -F -f $1/GL_ARB_shader_objects $1/GL_ARB_fragment_shader > tmp
+ mv tmp $1/GL_ARB_fragment_shader
+ grep -v -F -f $1/GL_ARB_shader_objects $1/GL_ARB_vertex_shader > tmp
+ mv tmp $1/GL_ARB_vertex_shader
+
+# remove duplicates in GL_ARB_vertex_program and GL_ARB_vertex_shader
+ grep -v -F -f $1/GL_ARB_vertex_program $1/GL_ARB_vertex_shader > tmp
+ mv tmp $1/GL_ARB_vertex_shader
+
+# remove triplicates in GL_ARB_fragment_program, GL_ARB_fragment_shader,
+# and GL_ARB_vertex_shader
+ grep -v -F -f $1/GL_ARB_fragment_program $1/GL_ARB_fragment_shader > tmp
+ mv tmp $1/GL_ARB_fragment_shader
+ grep -v -F -f $1/GL_ARB_fragment_program $1/GL_ARB_vertex_shader > tmp
+ mv tmp $1/GL_ARB_vertex_shader
+
+# remove duplicates in GL_EXT_direct_state_access
+ grep -v "glGetBooleanIndexedvEXT" $1/GL_EXT_direct_state_access > tmp
+ mv tmp $1/GL_EXT_direct_state_access
+ grep -v "glGetIntegerIndexedvEXT" $1/GL_EXT_direct_state_access > tmp
+ mv tmp $1/GL_EXT_direct_state_access
+ grep -v "glDisableIndexedEXT" $1/GL_EXT_direct_state_access > tmp
+ mv tmp $1/GL_EXT_direct_state_access
+ grep -v "glEnableIndexedEXT" $1/GL_EXT_direct_state_access > tmp
+ mv tmp $1/GL_EXT_direct_state_access
+ grep -v "glIsEnabledIndexedEXT" $1/GL_EXT_direct_state_access > tmp
+ mv tmp $1/GL_EXT_direct_state_access
+
+# remove duplicates in GL_NV_explicit_multisample
+ grep -v "glGetBooleanIndexedvEXT" $1/GL_NV_explicit_multisample > tmp
+ mv tmp $1/GL_NV_explicit_multisample
+ grep -v "glGetIntegerIndexedvEXT" $1/GL_NV_explicit_multisample > tmp
+ mv tmp $1/GL_NV_explicit_multisample
+
+# fix bugs in GL_ARB_vertex_shader
+ grep -v "GL_FLOAT" $1/GL_ARB_vertex_shader > tmp
+ mv tmp $1/GL_ARB_vertex_shader
+ perl -e 's/handle /GLhandleARB /g' -pi $1/GL_ARB_vertex_shader
+
+# fix bugs in GL_ARB_shader_objects
+ grep -v "GL_FLOAT " $1/GL_ARB_shader_objects > tmp
+ mv tmp $1/GL_ARB_shader_objects
+ grep -v "GL_INT " $1/GL_ARB_shader_objects > tmp
+ mv tmp $1/GL_ARB_shader_objects
+
+# add typedefs to GL_ARB_shader_objects
+ cat >> $1/GL_ARB_shader_objects <<EOT
+ typedef char GLcharARB
+ typedef unsigned int GLhandleARB
+EOT
+
+# add missing functions to GL_ARB_transpose_matrix
+ cat >> $1/GL_ARB_transpose_matrix <<EOT
+ void glLoadTransposeMatrixfARB (GLfloat m[16])
+ void glLoadTransposeMatrixdARB (GLdouble m[16])
+ void glMultTransposeMatrixfARB (GLfloat m[16])
+ void glMultTransposeMatrixdARB (GLdouble m[16])
+EOT
+
+# add missing tokens to GL_EXT_framebuffer_multisample
+ cat >> $1/GL_EXT_framebuffer_multisample <<EOT
+ GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE_EXT 0x8D56
+ GL_MAX_SAMPLES_EXT 0x8D57
+EOT
+
+# Filter out GL_NV_gpu_program_fp64 enums and functions
+ head -n3 $1/GL_NV_gpu_program_fp64 > tmp
+ mv tmp $1/GL_NV_gpu_program_fp64
+
+# Filter glGetUniformui64vNV from GL_NV_shader_buffer_load
+ grep -v "glGetUniformui64vNV" $1/GL_NV_shader_buffer_load > tmp
+ mv tmp $1/GL_NV_shader_buffer_load
+
+# Filter out profile enumerations from GLX_ARB_create_context
+ grep -v "_PROFILE_" $1/GLX_ARB_create_context > tmp
+ mv tmp $1/GLX_ARB_create_context
+
+# Filter only profile related enumerations for GLX_ARB_create_context_profile
+ head -n3 $1/GLX_ARB_create_context_profile > tmp
+ grep "_PROFILE_" $1/GLX_ARB_create_context_profile >> tmp
+ mv tmp $1/GLX_ARB_create_context_profile
+
+# Filter out profile enumerations from WGL_ARB_create_context
+ grep -v "_PROFILE_" $1/WGL_ARB_create_context > tmp
+ mv tmp $1/WGL_ARB_create_context
+
+# Filter only profile related enumerations for WGL_ARB_create_context_profile
+ head -n3 $1/WGL_ARB_create_context_profile > tmp
+ grep "_PROFILE_" $1/WGL_ARB_create_context_profile >> tmp
+ mv tmp $1/WGL_ARB_create_context_profile
+
+# add missing function to GLX_NV_copy_image
+ cat >> $1/GLX_NV_copy_image <<EOT
+ void glXCopyImageSubDataNV (Display *dpy, GLXContext srcCtx, GLuint srcName, GLenum srcTarget, GLint srcLevel, GLint srcX, GLint srcY, GLint srcZ, GLXContext dstCtx, GLuint dstName, GLenum dstTarget, GLint dstLevel, GLint dstX, GLint dstY, GLint dstZ, GLsizei width, GLsizei height, GLsizei depth)
+EOT
+
+# add missing function to WGL_NV_copy_image
+ cat >> $1/WGL_NV_copy_image <<EOT
+ BOOL wglCopyImageSubDataNV (HGLRC hSrcRC, GLuint srcName, GLenum srcTarget, GLint srcLevel, GLint srcX, GLint srcY, GLint srcZ, HGLRC hDstRC, GLuint dstName, GLenum dstTarget, GLint dstLevel, GLint dstX, GLint dstY, GLint dstZ, GLsizei width, GLsizei height, GLsizei depth)
+EOT
+
+# Filter glProgramParameteri from GL_ARB_separate_shader_objects
+# grep -v "glProgramParameteri" $1/GL_ARB_separate_shader_objects > tmp
+# mv tmp $1/GL_ARB_separate_shader_objects
+
+# Filter out EXT functions from GL_ARB_viewport_array
+ grep -v "EXT" $1/GL_ARB_viewport_array > tmp
+ mv tmp $1/GL_ARB_viewport_array
+
+# Additional enumerations for GL_NV_vertex_buffer_unified_memory
+# These are mentioned in GL_ARB_draw_indirect.txt
+
+ cat >> $1/GL_NV_vertex_buffer_unified_memory <<EOT
+ GL_DRAW_INDIRECT_UNIFIED_NV 0x8F40
+ GL_DRAW_INDIRECT_ADDRESS_NV 0x8F41
+ GL_DRAW_INDIRECT_LENGTH_NV 0x8F42
+EOT
+
+# Filter glGetPointerv from GL_ARB_debug_output
+# It's part of OpenGL 1.1, after all
+
+ grep -v "glGetPointerv" $1/GL_ARB_debug_output > tmp
+ mv tmp $1/GL_ARB_debug_output
+
+# Filter glGetPointerv from GL_EXT_vertex_array
+# It's part of OpenGL 1.1, after all
+
+ grep -v "glGetPointerv" $1/GL_EXT_vertex_array > tmp
+ mv tmp $1/GL_EXT_vertex_array
+
+# add typedef to GL_AMD_debug_output
+# parse_spec.pl can't parse typedefs from New Types section, but ought to
+ cat >> $1/GL_AMD_debug_output <<EOT
+ typedef void (GLAPIENTRY *GLDEBUGPROCAMD)(GLuint id, GLenum category, GLenum severity, GLsizei length, const GLchar* message, void* userParam)
+EOT
+
+# add typedef to GL_ARB_debug_output
+# parse_spec.pl can't parse typedefs from New Types section, but ought to
+ cat >> $1/GL_ARB_debug_output <<EOT
+ typedef void (GLAPIENTRY *GLDEBUGPROCARB)(GLenum source, GLenum type, GLuint id, GLenum severity, GLsizei length, const GLchar* message, const void* userParam)
+EOT
+
+# add typedef to GL_KHR_debug
+# parse_spec.pl can't parse typedefs from New Types section, but ought to
+ cat >> $1/GL_KHR_debug <<EOT
+ typedef void (GLAPIENTRY *GLDEBUGPROC)(GLenum source, GLenum type, GLuint id, GLenum severity, GLsizei length, const GLchar* message, const void* userParam)
+EOT
+
+# Remove glGetPointerv from GL_KHR_debug
+ grep -v "glGetPointerv" $1/GL_KHR_debug > tmp
+ mv tmp $1/GL_KHR_debug
+
+# Remove GL_ARB_debug_group, GL_ARB_debug_label and GL_ARB_debug_output2, for now
+ rm -f $1/GL_ARB_debug_group
+ rm -f $1/GL_ARB_debug_label
+ rm -f $1/GL_ARB_debug_output2
+
+# add typedefs to GL_ARB_cl_event
+# parse_spec.pl can't parse typedefs from New Types section, but ought to
+ cat >> $1/GL_ARB_cl_event <<EOT
+ typedef struct _cl_context *cl_context
+ typedef struct _cl_event *cl_event
+EOT
+
+# Filter out EXT functions from GL_ARB_gpu_shader_fp64
+ grep -v 'EXT ' $1/GL_ARB_gpu_shader_fp64 > tmp
+ mv tmp $1/GL_ARB_gpu_shader_fp64
+
+# add missing functions to GL_EXT_direct_state_access (GL_ARB_gpu_shader_fp64 related)
+ cat >> $1/GL_EXT_direct_state_access <<EOT
+ void glProgramUniform1dEXT (GLuint program, GLint location, GLdouble x)
+ void glProgramUniform2dEXT (GLuint program, GLint location, GLdouble x, GLdouble y)
+ void glProgramUniform3dEXT (GLuint program, GLint location, GLdouble x, GLdouble y, GLdouble z)
+ void glProgramUniform4dEXT (GLuint program, GLint location, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
+ void glProgramUniform1dvEXT (GLuint program, GLint location, GLsizei count, const GLdouble *value)
+ void glProgramUniform2dvEXT (GLuint program, GLint location, GLsizei count, const GLdouble *value)
+ void glProgramUniform3dvEXT (GLuint program, GLint location, GLsizei count, const GLdouble *value)
+ void glProgramUniform4dvEXT (GLuint program, GLint location, GLsizei count, const GLdouble *value)
+ void glProgramUniformMatrix2dvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
+ void glProgramUniformMatrix3dvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
+ void glProgramUniformMatrix4dvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
+ void glProgramUniformMatrix2x3dvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
+ void glProgramUniformMatrix2x4dvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
+ void glProgramUniformMatrix3x2dvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
+ void glProgramUniformMatrix3x4dvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
+ void glProgramUniformMatrix4x2dvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
+ void glProgramUniformMatrix4x3dvEXT (GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
+EOT
+
+# add missing functions to GL_EXT_direct_state_access (GL_ARB_instanced_arrays related)
+# https://sourceforge.net/p/glew/bugs/242/
+ cat >> $1/GL_EXT_direct_state_access <<EOT
+ void glVertexArrayVertexAttribDivisorEXT (GLuint vaobj, GLuint index, GLuint divisor)
+EOT
+
+# Filter out GL_UNSIGNED_INT and GL_FLOAT from GL_AMD_performance_monitor
+ grep -v 'GL_UNSIGNED_INT ' $1/GL_AMD_performance_monitor > tmp
+ mv tmp $1/GL_AMD_performance_monitor
+ grep -v 'GL_FLOAT ' $1/GL_AMD_performance_monitor > tmp
+ mv tmp $1/GL_AMD_performance_monitor
+
+# Filter out GL_STORAGE_CACHED_APPLE and GL_STORAGE_SHARED_APPLE from GL_APPLE_texture_range
+ grep -v 'GL_STORAGE_CACHED_APPLE ' $1/GL_APPLE_texture_range > tmp
+ mv tmp $1/GL_APPLE_texture_range
+ grep -v 'GL_STORAGE_SHARED_APPLE ' $1/GL_APPLE_texture_range > tmp
+ mv tmp $1/GL_APPLE_texture_range
+
+# Filter out GL_RED from GL_ARB_texture_rg
+ grep -v 'GL_RED ' $1/GL_ARB_texture_rg > tmp
+ mv tmp $1/GL_ARB_texture_rg
+
+# Filter out _EXT enums from GL_ARB_texture_storage
+ grep -v '_EXT ' $1/GL_ARB_texture_storage > tmp
+ mv tmp $1/GL_ARB_texture_storage
+
+# Filter out TEXTURE_3D enums from GL_EXT_paletted_texture
+ grep -v 'TEXTURE_3D' $1/GL_EXT_paletted_texture > tmp
+ mv tmp $1/GL_EXT_paletted_texture
+
+# Filter out GL_VERSION_1_1 enums from GL_AMD_stencil_operation_extended
+ grep -v '0x150' $1/GL_AMD_stencil_operation_extended > tmp
+ mv tmp $1/GL_AMD_stencil_operation_extended
+
+# Filter out from GL_APPLE_ycbcr_422
+ grep -v 'GL_UNSIGNED_SHORT_8_8_APPLE' $1/GL_APPLE_ycbcr_422 > tmp
+ mv tmp $1/GL_APPLE_ycbcr_422
+ grep -v 'GL_UNSIGNED_SHORT_8_8_REV_APPLE' $1/GL_APPLE_ycbcr_422 > tmp
+ mv tmp $1/GL_APPLE_ycbcr_422
+
+# Filter out GL_FRAGMENT_DEPTH_EXT from GL_EXT_light_texture
+ grep -v 'GL_FRAGMENT_DEPTH_EXT' $1/GL_EXT_light_texture > tmp
+ mv tmp $1/GL_EXT_light_texture
+
+# Filter out GL_MULTISAMPLE_BIT_EXT from GL_SGIS_multisample
+ grep -v 'GL_MULTISAMPLE_BIT_EXT' $1/GL_SGIS_multisample > tmp
+ mv tmp $1/GL_SGIS_multisample
+
+# Filter out GL_COMPRESSED_RGB_S3TC_DXT1_EXT from GL_EXT_texture_compression_dxt1
+ grep -v 'GL_COMPRESSED_RGB_S3TC_DXT1_EXT' $1/GL_EXT_texture_compression_dxt1 > tmp
+ mv tmp $1/GL_EXT_texture_compression_dxt1
+
+# Filter out GL_COMPRESSED_RGBA_S3TC_DXT1_EXT from GL_EXT_texture_compression_dxt1
+ grep -v 'GL_COMPRESSED_RGBA_S3TC_DXT1_EXT' $1/GL_EXT_texture_compression_dxt1 > tmp
+ mv tmp $1/GL_EXT_texture_compression_dxt1
+
+# Append GLfixed to GL_ARB_ES2_compatibility
+# Probably ought to be explicitly mentioned in the spec language
+
+ cat >> $1/GL_ARB_ES2_compatibility <<EOT
+ typedef int GLfixed
+EOT
+
+# Append GLclampx to GL_REGAL_ES1_0_compatibility
+# Probably ought to be explicitly mentioned in the spec language
+
+ cat >> $1/GL_REGAL_ES1_0_compatibility <<EOT
+ typedef int GLclampx
+EOT
+
+# Append GLLOGPROCREGAL to GL_REGAL_log
+# Probably ought to be explicitly mentioned in the spec language
+
+ cat >> $1/GL_REGAL_log <<EOT
+ typedef void (APIENTRY *LOGPROCREGAL)(GLenum stream, GLsizei length, const GLchar *message, void *context)
+EOT
+
+# Fixup LOGPROCREGAL -> GLLOGPROCREGAL
+ perl -e 's/LOGPROCREGAL/GLLOGPROCREGAL/g' -pi $1/GL_REGAL_log
+
+# Filter out GL_BYTE from GL_OES_byte_coordinates
+ grep -v 'GL_BYTE' $1/GL_OES_byte_coordinates > tmp
+ mv tmp $1/GL_OES_byte_coordinates
+
+# Filter out fp64 (not widely supported) from GL_EXT_direct_state_access
+ egrep -v 'glProgramUniform.*[1234]d[v]?EXT' $1/GL_EXT_direct_state_access > tmp
+ mv tmp $1/GL_EXT_direct_state_access
+
+# Filter out all enums from GL_ANGLE_depth_texture
+ grep -v '0x' $1/GL_ANGLE_depth_texture > tmp
+ mv tmp $1/GL_ANGLE_depth_texture
+
+# Filter out GL_NONE enum from GL_ANGLE_depth_texture
+ grep -v 'GL_NONE' $1/GL_ANGLE_texture_usage > tmp
+ mv tmp $1/GL_ANGLE_texture_usage
+
+# Fixup REGAL and ANGLE urls
+
+ for i in $1/GL_REGAL_*; do perl -e 's#http://www.opengl.org/registry/specs/REGAL/.*#https://github.com/p3/regal/tree/master/doc/extensions#g' -pi $i; done
+ for i in $1/GL_ANGLE_*; do perl -e 's#http://www.opengl.org/registry/specs/ANGLE/.*#https://code.google.com/p/angleproject/source/browse/\#git%2Fextensions#g' -pi $i; done
+
+# Filter out GL_NV_blend_equation_advanced_coherent enums and functions
+ head -n3 $1/GL_NV_blend_equation_advanced_coherent > tmp
+ mv tmp $1/GL_NV_blend_equation_advanced_coherent
+
+# Filter out GL_AMD_gpu_shader_int64 enums and functions
+ head -n3 $1/GL_AMD_gpu_shader_int64 > tmp
+ mv tmp $1/GL_AMD_gpu_shader_int64
+
+# Filter out GL_NO_ERROR enum from GL_KHR_robustness
+ grep -v 'GL_NO_ERROR' $1/GL_KHR_robustness > tmp
+ mv tmp $1/GL_KHR_robustness
+
+# Filter out all enums from GL_KHR_blend_equation_advanced_coherent
+ grep -v '0x' $1/GL_KHR_blend_equation_advanced_coherent > tmp
+ mv tmp $1/GL_KHR_blend_equation_advanced_coherent
+
+# Filter out glBlendBarrierKHR enum from GL_KHR_blend_equation_advanced_coherent
+ grep -v 'glBlendBarrierKHR' $1/GL_KHR_blend_equation_advanced_coherent > tmp
+ mv tmp $1/GL_KHR_blend_equation_advanced_coherent
+
+# Filter out GL_NONE enum from GL_KHR_robustness
+ grep -v 'GL_NONE' $1/GL_KHR_context_flush_control > tmp
+ mv tmp $1/GL_KHR_context_flush_control
+
+# Filter out CoverageModulation from NV_framebuffer_mixed_samples
+# Superset of EXT_raster_multisample
+
+ grep -v "CoverageModulation" $1/GL_NV_framebuffer_mixed_samples > tmp
+ mv tmp $1/GL_NV_framebuffer_mixed_samples
+
+# Filter out glRasterSamplesEXT from NV_framebuffer_mixed_samples
+# Superset of EXT_raster_multisample
+
+ grep -v "RasterSamplesEXT" $1/GL_NV_framebuffer_mixed_samples > tmp
+ mv tmp $1/GL_NV_framebuffer_mixed_samples
+
+# clean up
+ rm -f $1/*.bak
diff --git a/auto/bin/filter_gles_ext.sh b/auto/bin/filter_gles_ext.sh
new file mode 100755
index 0000000..fa2fe4f
--- /dev/null
+++ b/auto/bin/filter_gles_ext.sh
@@ -0,0 +1,19 @@
+#!/bin/bash
+##
+## Copyright (C) 2002-2008, Marcelo E. Magallon <mmagallo[]debian org>
+## Copyright (C) 2002-2008, Milan Ikits <milan ikits[]ieee org>
+##
+## This program is distributed under the terms and conditions of the GNU
+## General Public License Version 2 as published by the Free Software
+## Foundation or, at your option, any later version.
+##
+## Parameters:
+##
+## $1: Extensions directory
+## $2: Registry directory
+## $3: The black list
+
+set -e
+
+# clean up
+ rm -f $1/*.bak
diff --git a/auto/bin/filter_spec.py b/auto/bin/filter_spec.py
new file mode 100755
index 0000000..16c2fa9
--- /dev/null
+++ b/auto/bin/filter_spec.py
@@ -0,0 +1,38 @@
+#!/usr/bin/python
+
+import re
+
+section = re.compile('^(Name|Name Strings?|Contact|Notice|Number|Dependencies|Overview|Issues|IP Status|Status|Version|New Procedures and Functions|New Tokens|Additions to .*|Changes to .*|Modifications to .*|Add new Section .*)\s*$')
+token = re.compile('^\s+(([A-Z0-9][A-Z0-9_x]*):?\s+((?:0x)?[0-9A-F]+)([^\?]*))?\s*$')
+match = [ 'Name', 'Name String', 'Contact', 'Notice', 'Name Strings', 'Version', 'Number', 'Dependencies', 'New Procedures and Functions', 'New Tokens']
+
+if __name__ == '__main__':
+
+ from optparse import OptionParser
+ import os
+
+ parser = OptionParser('usage: %prog [options] [SOURCES...]')
+ (options, args) = parser.parse_args()
+
+ for i in args:
+ lines = open(i).readlines()
+ f = open(i,'w')
+
+ # Keep track of the current section as we iterate over the input
+ current = ''
+ for j in lines:
+
+ # Detect the start of a new section
+ m = section.match(j)
+ if m:
+ current = m.group(1).strip()
+ if current in match:
+ print >>f, j,
+ continue
+
+ if current=='New Tokens':
+ if token.match(j):
+ print >>f, j,
+ elif current in match:
+ print >>f, j,
+
diff --git a/auto/bin/make.pl b/auto/bin/make.pl
new file mode 100755
index 0000000..1bd5d40
--- /dev/null
+++ b/auto/bin/make.pl
@@ -0,0 +1,209 @@
+##
+## Copyright (C) 2002-2008, Marcelo E. Magallon <mmagallo[]debian org>
+## Copyright (C) 2002-2008, Milan Ikits <milan ikits[]ieee org>
+##
+## This program is distributed under the terms and conditions of the GNU
+## General Public License Version 2 as published by the Free Software
+## Foundation or, at your option, any later version.
+
+my %regex = (
+ extname => qr/^[A-Z][A-Za-z0-9_]+$/,
+ exturl => qr/^http.+$/,
+ function => qr/^(.+) ([a-z][a-z0-9_]*) \((.+)\)$/i,
+ token => qr/^([A-Z][A-Z0-9_x]*)\s+((?:0x)?[0-9A-Fa-f]+|[A-Z][A-Z0-9_]*)$/,
+ type => qr/^typedef\s+(.+)$/,
+ exact => qr/.*;$/,
+);
+
+# prefix function name with glew
+sub prefixname($)
+{
+ my $name = $_[0];
+ $name =~ s/^(.*?)gl/__$1glew/;
+ return $name;
+}
+
+# prefix function name with glew
+sub prefix_varname($)
+{
+ my $name = $_[0];
+ $name =~ s/^(.*?)GL(X*?)EW/__$1GL$2EW/;
+ return $name;
+}
+
+#---------------------------------------------------------------------------------------
+
+sub make_exact($)
+{
+ my $exact = $_[0];
+ $exact =~ s/(; |{)/$1\n/g;
+ return $exact;
+}
+
+sub make_separator($)
+{
+ my $extname = $_[0];
+ my $l = length $extname;
+ my $s = (71 - $l)/2;
+ print "/* ";
+ my $j = 3;
+ for (my $i = 0; $i < $s; $i++)
+ {
+ print "-";
+ $j++;
+ }
+ print " $_[0] ";
+ $j += $l + 2;
+ while ($j < 76)
+ {
+ print "-";
+ $j++;
+ }
+ print " */\n\n";
+}
+
+#---------------------------------------------------------------------------------------
+
+sub parse_ext($)
+{
+ my $filename = shift;
+ my %functions = ();
+ my %tokens = ();
+ my @types = ();
+ my @exacts = ();
+ my $extname = ""; # Full extension name GL_FOO_extension
+ my $exturl = ""; # Info URL
+ my $extstring = ""; # Relevant extension string
+
+ open EXT, "<$filename" or return;
+
+ # As of GLEW 1.5.3 the first three lines _must_ be
+ # the extension name, the URL and the GL extension
+ # string (which might be different to the name)
+ #
+ # For example GL_NV_geometry_program4 is available
+ # iff GL_NV_gpu_program4 appears in the extension
+ # string.
+ #
+ # For core OpenGL versions, the third line should
+ # be blank.
+ #
+ # If the URL is unknown, the second line should be
+ # blank.
+
+ $extname = readline(*EXT);
+ $exturl = readline(*EXT);
+ $extstring = readline(*EXT);
+
+ chomp($extname);
+ chomp($exturl);
+ chomp($extstring);
+
+ while(<EXT>)
+ {
+ chomp;
+ if (s/^\s+//)
+ {
+ if (/$regex{exact}/)
+ {
+ push @exacts, $_;
+ }
+ elsif (/$regex{type}/)
+ {
+ push @types, $_;
+ }
+ elsif (/$regex{token}/)
+ {
+ my ($name, $value) = ($1, $2);
+ $tokens{$name} = $value;
+ }
+ elsif (/$regex{function}/)
+ {
+ my ($return, $name, $parms) = ($1, $2, $3);
+ $functions{$name} = {
+ rtype => $return,
+ parms => $parms,
+ };
+ } else {
+ print STDERR "'$_' matched no regex.\n";
+ }
+ }
+ }
+
+ close EXT;
+
+ return ($extname, $exturl, $extstring, \@types, \%tokens, \%functions, \@exacts);
+}
+
+sub output_tokens($$)
+{
+ my ($tbl, $fnc) = @_;
+ if (keys %{$tbl})
+ {
+ local $, = "\n";
+ print "\n";
+ print map { &{$fnc}($_, $tbl->{$_}) } sort {
+ if (${$tbl}{$a} eq ${$tbl}{$b}) {
+ $a cmp $b
+ } else {
+ if (${$tbl}{$a} =~ /_/) {
+ if (${$tbl}{$b} =~ /_/) {
+ $a cmp $b
+ } else {
+ -1
+ }
+ } else {
+ if (${$tbl}{$b} =~ /_/) {
+ 1
+ } else {
+ if (hex ${$tbl}{$a} eq hex ${$tbl}{$b}) {
+ $a cmp $b
+ } else {
+ hex ${$tbl}{$a} <=> hex ${$tbl}{$b}
+ }
+ }
+ }
+ }
+ } keys %{$tbl};
+ print "\n";
+ } else {
+ print STDERR "no keys in table!\n";
+ }
+}
+
+sub output_types($$)
+{
+ my ($tbl, $fnc) = @_;
+ if (scalar @{$tbl})
+ {
+ local $, = "\n";
+ print "\n";
+ print map { &{$fnc}($_) } sort @{$tbl};
+ print "\n";
+ }
+}
+
+sub output_decls($$)
+{
+ my ($tbl, $fnc) = @_;
+ if (keys %{$tbl})
+ {
+ local $, = "\n";
+ print "\n";
+ print map { &{$fnc}($_, $tbl->{$_}) } sort keys %{$tbl};
+ print "\n";
+ }
+}
+
+sub output_exacts($$)
+{
+ my ($tbl, $fnc) = @_;
+ if (scalar @{$tbl})
+ {
+ local $, = "\n";
+ print "\n";
+ print map { &{$fnc}($_) } sort @{$tbl};
+ print "\n";
+ }
+}
+
diff --git a/auto/bin/make_def_fun.pl b/auto/bin/make_def_fun.pl
new file mode 100755
index 0000000..40e67d5
--- /dev/null
+++ b/auto/bin/make_def_fun.pl
@@ -0,0 +1,35 @@
+#!/usr/bin/perl
+##
+## Copyright (C) 2002-2008, Marcelo E. Magallon <mmagallo[]debian org>
+## Copyright (C) 2002-2008, Milan Ikits <milan ikits[]ieee org>
+##
+## This program is distributed under the terms and conditions of the GNU
+## General Public License Version 2 as published by the Free Software
+## Foundation or, at your option, any later version.
+
+use strict;
+use warnings;
+
+do 'bin/make.pl';
+
+# function pointer declaration
+sub make_pfn_decl($%)
+{
+ return "PFN" . (uc $_[0]) . "PROC " . prefixname($_[0]) . " = NULL;";
+}
+
+my @extlist = ();
+my %extensions = ();
+
+our $type = shift;
+
+if (@ARGV)
+{
+ @extlist = @ARGV;
+
+ foreach my $ext (sort @extlist)
+ {
+ my ($extname, $exturl, $extstring, $types, $tokens, $functions, $exacts) = parse_ext($ext);
+ output_decls($functions, \&make_pfn_decl);
+ }
+}
diff --git a/auto/bin/make_def_var.pl b/auto/bin/make_def_var.pl
new file mode 100755
index 0000000..2b2a1d9
--- /dev/null
+++ b/auto/bin/make_def_var.pl
@@ -0,0 +1,31 @@
+#!/usr/bin/perl
+##
+## Copyright (C) 2002-2008, Marcelo E. Magallon <mmagallo[]debian org>
+## Copyright (C) 2002-2008, Milan Ikits <milan ikits[]ieee org>
+##
+## This program is distributed under the terms and conditions of the GNU
+## General Public License Version 2 as published by the Free Software
+## Foundation or, at your option, any later version.
+
+use strict;
+use warnings;
+
+do 'bin/make.pl';
+
+my @extlist = ();
+my %extensions = ();
+
+our $type = shift;
+
+if (@ARGV)
+{
+ @extlist = @ARGV;
+
+ foreach my $ext (sort @extlist)
+ {
+ my ($extname, $exturl, $extstring, $types, $tokens, $functions, $exacts) = parse_ext($ext);
+ my $extvar = $extname;
+ $extvar =~ s/GL(X*)_/GL$1EW_/;
+ print "GLboolean " . prefix_varname($extvar) . " = GL_FALSE;\n";
+ }
+}
diff --git a/auto/bin/make_header.pl b/auto/bin/make_header.pl
new file mode 100755
index 0000000..934ef77
--- /dev/null
+++ b/auto/bin/make_header.pl
@@ -0,0 +1,71 @@
+#!/usr/bin/perl
+##
+## Copyright (C) 2002-2008, Marcelo E. Magallon <mmagallo[]debian org>
+## Copyright (C) 2002-2008, Milan Ikits <milan ikits[]ieee org>
+##
+## This program is distributed under the terms and conditions of the GNU
+## General Public License Version 2 as published by the Free Software
+## Foundation or, at your option, any later version.
+
+use strict;
+use warnings;
+
+do 'bin/make.pl';
+
+# token
+sub make_define($$)
+{
+ return "#define $_[0] $_[1]"
+}
+
+# type declaration
+sub make_type($$)
+{
+ return "@_;"
+}
+
+# function pointer type declaration
+sub make_pfn_type($%)
+{
+ our $api;
+ return join(' ', "typedef", $_[1]->{rtype},
+ "($api * PFN" . (uc $_[0]) . "PROC)",
+ "(" . $_[1]->{parms} . ")") . ";";
+}
+
+# function name alias
+sub make_pfn_alias($%)
+{
+ our $type;
+ return join(" ", "#define", $_[0], $type . "EW_GET_FUN(" . prefixname($_[0]) . ")")
+}
+
+my @extlist = ();
+my %extensions = ();
+
+our $api = shift;
+our $type = shift;
+
+if (@ARGV)
+{
+ @extlist = @ARGV;
+
+ foreach my $ext (sort @extlist)
+ {
+ my ($extname, $exturl, $extstring, $types, $tokens, $functions, $exacts) = parse_ext($ext);
+
+ make_separator($extname);
+ print "#ifndef $extname\n#define $extname 1\n";
+ output_tokens($tokens, \&make_define);
+ output_types($types, \&make_type);
+ output_exacts($exacts, \&make_exact);
+ output_decls($functions, \&make_pfn_type);
+ output_decls($functions, \&make_pfn_alias);
+
+ my $extvar = $extname;
+ $extvar =~ s/GL(X*)_/GL$1EW_/;
+
+ print "\n#define $extvar " . $type . "EW_GET_VAR(" . prefix_varname($extvar) . ")\n";
+ print "\n#endif /* $extname */\n\n";
+ }
+}
diff --git a/auto/bin/make_html.pl b/auto/bin/make_html.pl
new file mode 100755
index 0000000..ee58196
--- /dev/null
+++ b/auto/bin/make_html.pl
@@ -0,0 +1,55 @@
+#!/usr/bin/perl
+##
+## Copyright (C) 2002-2008, Marcelo E. Magallon <mmagallo[]debian org>
+## Copyright (C) 2002-2008, Milan Ikits <milan ikits[]ieee org>
+##
+## This program is distributed under the terms and conditions of the GNU
+## General Public License Version 2 as published by the Free Software
+## Foundation or, at your option, any later version.
+
+use strict;
+use warnings;
+
+do 'bin/make.pl';
+
+#---------------------------------------------------------------------------------------
+
+my @extlist = ();
+my %extensions = ();
+my $group = "";
+my $cur_group = "";
+
+if (@ARGV)
+{
+ @extlist = @ARGV;
+ my $n = 1;
+ print "<table border=\"0\" width=\"100%\" cellpadding=\"1\" cellspacing=\"0\" align=\"center\">\n";
+ foreach my $ext (sort @extlist)
+ {
+ my ($extname, $exturl, $extstring, $types, $tokens, $functions, $exacts) = parse_ext($ext);
+ $cur_group = $extname;
+ $cur_group =~ s/^(?:W?)GL(?:X?)_([A-Z0-9]+?)_.*$/$1/;
+ $extname =~ s/^(?:W?)GL(?:X?)_(.*)$/$1/;
+ if ($cur_group ne $group)
+ {
+ if ($group ne "")
+ {
+ print "<tr><td><br></td><td></td><td></td></tr>\n";
+ }
+ $group = $cur_group;
+ }
+
+ {
+ if ($exturl)
+ {
+ print "<tr><td class=\"num\">$n</td><td>&nbsp;</td><td><a href=\"$exturl\">$extname</a></td></tr>\n";
+ }
+ else
+ {
+ print "<tr><td class=\"num\">$n</td><td>&nbsp;</td><td>$extname</td></tr>\n";
+ }
+ $n++;
+ }
+ }
+ print "</table>\n"
+}
diff --git a/auto/bin/make_info.pl b/auto/bin/make_info.pl
new file mode 100755
index 0000000..5d0c7f6
--- /dev/null
+++ b/auto/bin/make_info.pl
@@ -0,0 +1,59 @@
+#!/usr/bin/perl
+##
+## Copyright (C) 2002-2008, Marcelo E. Magallon <mmagallo[]debian org>
+## Copyright (C) 2002-2008, Milan Ikits <milan ikits[]ieee org>
+##
+## This program is distributed under the terms and conditions of the GNU
+## General Public License Version 2 as published by the Free Software
+## Foundation or, at your option, any later version.
+
+use strict;
+use warnings;
+
+do 'bin/make.pl';
+
+#---------------------------------------------------------------------------------------
+
+# function pointer definition
+sub make_pfn_info($%)
+{
+ my $name = $_[0];
+ return " glewInfoFunc(\"$_[0]\", $name == NULL);";
+}
+
+#---------------------------------------------------------------------------------------
+
+my @extlist = ();
+my %extensions = ();
+
+if (@ARGV)
+{
+ @extlist = @ARGV;
+
+ foreach my $ext (sort @extlist)
+ {
+ my ($extname, $exturl, $extstring, $types, $tokens, $functions, $exacts) = parse_ext($ext);
+ my $extvar = $extname;
+ $extvar =~ s/GL(X*)_/GL$1EW_/;
+ my $extpre = $extname;
+ $extpre =~ s/(GLX|GLW|GL).*/$1/;
+ $extpre = lc $extpre;
+
+ #make_separator($extname);
+ print "#ifdef $extname\n\n";
+ print "static void _glewInfo_$extname (void)\n{\n";
+ if ($extvar =~ /VERSION/)
+ {
+ print " glewPrintExt(\"$extname\", $extvar, $extvar, $extvar);\n";
+ }
+ else
+ {
+ print " glewPrintExt(\"$extname\", $extvar, $extpre" .
+ "ewIsSupported(\"$extname\"), $extpre" .
+ "ewGetExtension(\"$extstring\"));\n";
+ }
+ output_decls($functions, \&make_pfn_info);
+ print "}\n\n";
+ print "#endif /* $extname */\n\n";
+ }
+}
diff --git a/auto/bin/make_info_list.pl b/auto/bin/make_info_list.pl
new file mode 100755
index 0000000..a55106d
--- /dev/null
+++ b/auto/bin/make_info_list.pl
@@ -0,0 +1,47 @@
+#!/usr/bin/perl
+##
+## Copyright (C) 2002-2008, Marcelo E. Magallon <mmagallo[]debian org>
+## Copyright (C) 2002-2008, Milan Ikits <milan ikits[]ieee org>
+##
+## This program is distributed under the terms and conditions of the GNU
+## General Public License Version 2 as published by the Free Software
+## Foundation or, at your option, any later version.
+
+use strict;
+use warnings;
+
+do 'bin/make.pl';
+
+#---------------------------------------------------------------------------------------
+
+# function pointer definition
+sub make_pfn_def($%)
+{
+ return "PFN" . (uc $_[0]) . "PROC " . prefixname($_[0]) . " = NULL;";
+}
+
+# function pointer definition
+sub make_init_call($%)
+{
+ my $name = prefixname($_[0]);
+ return " r = r || (" . $name . " = (PFN" . (uc $_[0]) . "PROC)glewGetProcAddress((const GLubyte*)\"" . $name . "\")) == NULL;";
+}
+
+#---------------------------------------------------------------------------------------
+
+my @extlist = ();
+my %extensions = ();
+
+if (@ARGV)
+{
+ @extlist = @ARGV;
+
+ foreach my $ext (sort @extlist)
+ {
+ my ($extname, $exturl, $extstring, $types, $tokens, $functions, $exacts) = parse_ext($ext);
+
+ print "#ifdef $extname\n";
+ print " _glewInfo_$extname();\n";
+ print "#endif /* $extname */\n";
+ }
+}
diff --git a/auto/bin/make_init.pl b/auto/bin/make_init.pl
new file mode 100755
index 0000000..5e6200a
--- /dev/null
+++ b/auto/bin/make_init.pl
@@ -0,0 +1,54 @@
+#!/usr/bin/perl
+##
+## Copyright (C) 2002-2008, Marcelo E. Magallon <mmagallo[]debian org>
+## Copyright (C) 2002-2008, Milan Ikits <milan ikits[]ieee org>
+##
+## This program is distributed under the terms and conditions of the GNU
+## General Public License Version 2 as published by the Free Software
+## Foundation or, at your option, any later version.
+
+use strict;
+use warnings;
+
+do 'bin/make.pl';
+
+#-------------------------------------------------------------------------------
+
+# function pointer definition
+sub make_pfn_def_init($%)
+{
+ #my $name = prefixname($_[0]);
+ return " r = ((" . $_[0] . " = (PFN" . (uc $_[0]) . "PROC)glewGetProcAddress((const GLubyte*)\"" . $_[0] . "\")) == NULL) || r;";
+}
+
+#-------------------------------------------------------------------------------
+
+my @extlist = ();
+my %extensions = ();
+
+our $type = shift;
+
+if (@ARGV)
+{
+ @extlist = @ARGV;
+
+ foreach my $ext (sort @extlist)
+ {
+ my ($extname, $exturl, $extstring, $types, $tokens, $functions, $exacts) =
+ parse_ext($ext);
+
+ #make_separator($extname);
+ my $extvar = $extname;
+ my $extvardef = $extname;
+ $extvar =~ s/GL(X*)_/GL$1EW_/;
+ if (keys %$functions)
+ {
+ print "#ifdef $extname\n\n";
+ print "static GLboolean _glewInit_$extname (" . $type .
+ "EW_CONTEXT_ARG_DEF_INIT)\n{\n GLboolean r = GL_FALSE;\n";
+ output_decls($functions, \&make_pfn_def_init);
+ print "\n return r;\n}\n\n";
+ print "#endif /* $extname */\n\n";
+ }
+ }
+}
diff --git a/auto/bin/make_list.pl b/auto/bin/make_list.pl
new file mode 100755
index 0000000..75dc060
--- /dev/null
+++ b/auto/bin/make_list.pl
@@ -0,0 +1,66 @@
+#!/usr/bin/perl
+##
+## Copyright (C) 2002-2008, Marcelo E. Magallon <mmagallo[]debian org>
+## Copyright (C) 2002-2008, Milan Ikits <milan ikits[]ieee org>
+##
+## This program is distributed under the terms and conditions of the GNU
+## General Public License Version 2 as published by the Free Software
+## Foundation or, at your option, any later version.
+
+use strict;
+use warnings;
+
+do 'bin/make.pl';
+
+#---------------------------------------------------------------------------------------
+
+# function pointer definition
+sub make_init_call($%)
+{
+ my $name = prefixname($_[0]);
+ return " r = r || (" . $_[0] . " = (PFN" . (uc $_[0]) . "PROC)glewGetProcAddress(\"" . $name . "\")) == NULL;";
+}
+
+#---------------------------------------------------------------------------------------
+
+my @extlist = ();
+my %extensions = ();
+
+if (@ARGV)
+{
+ @extlist = @ARGV;
+
+ foreach my $ext (sort @extlist)
+ {
+ my ($extname, $exturl, $extstring, $types, $tokens, $functions, $exacts) = parse_ext($ext);
+
+ my $extvar = $extname;
+ $extvar =~ s/GL(X*)_/GL$1EW_/;
+
+ my $extpre = $extname;
+ $extpre =~ s/^(W?)GL(X?).*$/\l$1gl\l$2ew/;
+
+ #my $pextvar = prefix_varname($extvar);
+
+ print "#ifdef $extname\n";
+
+ if (length($extstring))
+ {
+ print " " . $extvar . " = _glewSearchExtension(\"$extstring\", extStart, extEnd);\n";
+ }
+
+ if (keys %$functions)
+ {
+ if ($extname =~ /WGL_.*/)
+ {
+ print " if (glewExperimental || " . $extvar . "|| crippled) " . $extvar . "= !_glewInit_$extname(GLEW_CONTEXT_ARG_VAR_INIT);\n";
+ }
+ else
+ {
+ print " if (glewExperimental || " . $extvar . ") " . $extvar . " = !_glewInit_$extname(GLEW_CONTEXT_ARG_VAR_INIT);\n";
+ }
+ }
+ print "#endif /* $extname */\n";
+ }
+
+}
diff --git a/auto/bin/make_str.pl b/auto/bin/make_str.pl
new file mode 100755
index 0000000..ac4a366
--- /dev/null
+++ b/auto/bin/make_str.pl
@@ -0,0 +1,53 @@
+#!/usr/bin/perl
+##
+## Copyright (C) 2002-2008, Marcelo E. Magallon <mmagallo[]debian org>
+## Copyright (C) 2002-2008, Milan Ikits <milan ikits[]ieee org>
+##
+## This program is distributed under the terms and conditions of the GNU
+## General Public License Version 2 as published by the Free Software
+## Foundation or, at your option, any later version.
+
+use strict;
+use warnings;
+
+do 'bin/make.pl';
+
+my @extlist = ();
+my %extensions = ();
+
+if (@ARGV)
+{
+ @extlist = @ARGV;
+
+ my $curexttype = "";
+ foreach my $ext (sort @extlist)
+ {
+ my ($extname, $exturl, $extstring, $types, $tokens, $functions, $exacts) = parse_ext($ext);
+ my $exttype = $extname;
+ $exttype =~ s/(W*?)GL(X*?)_(.*?_)(.*)/$3/;
+ my $extrem = $extname;
+ $extrem =~ s/(W*?)GL(X*?)_(.*?_)(.*)/$4/;
+ my $extvar = $extname;
+ $extvar =~ s/(W*)GL(X*)_/$1GL$2EW_/;
+ if(!($exttype =~ $curexttype))
+ {
+ if(length($curexttype) > 0)
+ {
+ print " }\n";
+ }
+ print " if (_glewStrSame2(&pos, &len, (const GLubyte*)\"$exttype\", " . length($exttype) . "))\n";
+ print " {\n";
+ $curexttype = $exttype;
+ }
+ print "#ifdef $extname\n";
+ print " if (_glewStrSame3(&pos, &len, (const GLubyte*)\"$extrem\", ". length($extrem) . "))\n";
+ #print " return $extvar;\n";
+ print " {\n";
+ print " ret = $extvar;\n";
+ print " continue;\n";
+ print " }\n";
+ print "#endif\n";
+ }
+
+ print " }\n";
+}
diff --git a/auto/bin/make_struct_fun.pl b/auto/bin/make_struct_fun.pl
new file mode 100755
index 0000000..c885960
--- /dev/null
+++ b/auto/bin/make_struct_fun.pl
@@ -0,0 +1,36 @@
+#!/usr/bin/perl
+##
+## Copyright (C) 2002-2008, Marcelo E. Magallon <mmagallo[]debian org>
+## Copyright (C) 2002-2008, Milan Ikits <milan ikits[]ieee org>
+##
+## This program is distributed under the terms and conditions of the GNU
+## General Public License Version 2 as published by the Free Software
+## Foundation or, at your option, any later version.
+
+use strict;
+use warnings;
+
+do 'bin/make.pl';
+
+# function pointer declaration
+sub make_pfn_decl($%)
+{
+ our $export;
+ return $export . " PFN" . (uc $_[0]) . "PROC " . prefixname($_[0]) . ";";
+}
+
+my @extlist = ();
+my %extensions = ();
+
+our $export = shift;
+
+if (@ARGV)
+{
+ @extlist = @ARGV;
+
+ foreach my $ext (sort @extlist)
+ {
+ my ($extname, $exturl, $extstring, $types, $tokens, $functions, $exacts) = parse_ext($ext);
+ output_decls($functions, \&make_pfn_decl);
+ }
+}
diff --git a/auto/bin/make_struct_var.pl b/auto/bin/make_struct_var.pl
new file mode 100755
index 0000000..c7ba2f4
--- /dev/null
+++ b/auto/bin/make_struct_var.pl
@@ -0,0 +1,31 @@
+#!/usr/bin/perl
+##
+## Copyright (C) 2002-2008, Marcelo E. Magallon <mmagallo[]debian org>
+## Copyright (C) 2002-2008, Milan Ikits <milan ikits[]ieee org>
+##
+## This program is distributed under the terms and conditions of the GNU
+## General Public License Version 2 as published by the Free Software
+## Foundation or, at your option, any later version.
+
+use strict;
+use warnings;
+
+do 'bin/make.pl';
+
+my @extlist = ();
+my %extensions = ();
+
+our $export = shift;
+
+if (@ARGV)
+{
+ @extlist = @ARGV;
+
+ foreach my $ext (sort @extlist)
+ {
+ my ($extname, $exturl, $extstring, $types, $tokens, $functions, $exacts) = parse_ext($ext);
+ my $extvar = $extname;
+ $extvar =~ s/GL(X*)_/GL$1EW_/;
+ print $export . " GLboolean " . prefix_varname($extvar) . ";\n";
+ }
+}
diff --git a/auto/bin/parse_spec.pl b/auto/bin/parse_spec.pl
new file mode 100755
index 0000000..00fdde9
--- /dev/null
+++ b/auto/bin/parse_spec.pl
@@ -0,0 +1,378 @@
+#!/usr/bin/perl
+##
+## Copyright (C) 2002-2008, Marcelo E. Magallon <mmagallo[]debian org>
+## Copyright (C) 2002-2008, Milan Ikits <milan ikits[]ieee org>
+##
+## This program is distributed under the terms and conditions of the GNU
+## General Public License Version 2 as published by the Free Software
+## Foundation or, at your option, any later version.
+
+use strict;
+use warnings;
+
+sub compile_regex
+{
+ my $regex = join('', @_);
+ return qr/$regex/
+}
+
+my @sections = (
+ "Name",
+ "Name Strings?",
+ "New Procedures and Functions",
+ "New Tokens.*", # Optional (GL/WGL/GLX/...) suffix
+ "Additions to Chapter.*",
+);
+
+my %typemap = (
+ bitfield => "GLbitfield",
+ boolean => "GLboolean",
+ # fsck up in EXT_vertex_array
+ Boolean => "GLboolean",
+ byte => "GLbyte",
+ clampd => "GLclampd",
+ clampf => "GLclampf",
+ double => "GLdouble",
+ enum => "GLenum",
+ # Intel fsck up
+ Glenum => "GLenum",
+ float => "GLfloat",
+ half => "GLhalf",
+ int => "GLint",
+ short => "GLshort",
+ sizei => "GLsizei",
+ ubyte => "GLubyte",
+ uint => "GLuint",
+ ushort => "GLushort",
+ DMbuffer => "void *",
+ # Nvidia video output fsck up
+ int64EXT => "GLint64EXT",
+ uint64EXT=> "GLuint64EXT",
+
+ # ARB VBO introduces these.
+
+ sizeiptr => "GLsizeiptr",
+ intptr => "GLintptr",
+ sizeiptrARB => "GLsizeiptrARB",
+ intptrARB => "GLintptrARB",
+
+ # ARB shader objects introduces these, charARB is at least 8 bits,
+ # handleARB is at least 32 bits
+ charARB => "GLcharARB",
+ handleARB => "GLhandleARB",
+
+ char => "GLchar",
+
+ # OpenGL 3.2 and GL_ARB_sync
+
+ int64 => "GLint64",
+ uint64 => "GLuint64",
+ sync => "GLsync",
+
+ # AMD_debug_output
+
+ DEBUGPROCAMD => "GLDEBUGPROCAMD",
+
+ # ARB_debug_output
+
+ DEBUGPROCARB => "GLDEBUGPROCARB",
+
+ # KHR_debug
+
+ DEBUGPROC => "GLDEBUGPROC",
+
+ vdpauSurfaceNV => "GLvdpauSurfaceNV",
+
+ # GLX 1.3 defines new types which might not be available at compile time
+
+ #GLXFBConfig => "void*",
+ #GLXFBConfigID => "XID",
+ #GLXContextID => "XID",
+ #GLXWindow => "XID",
+ #GLXPbuffer => "XID",
+
+ # Weird stuff to some SGIX extension
+
+ #GLXFBConfigSGIX => "void*",
+ #GLXFBConfigIDSGIX => "XID",
+
+);
+
+my %voidtypemap = (
+ void => "GLvoid",
+);
+
+my %taboo_tokens = (
+ GL_ZERO => 1,
+);
+
+# list of function definitions to be ignored, unless they are being defined in
+# the given spec. This is an ugly hack arround the fact that people writing
+# spec files seem to shut down all brain activity while they are at this task.
+#
+# This will be moved to its own file eventually.
+#
+# (mem, 2003-03-19)
+
+my %fnc_ignore_list = (
+ "BindProgramARB" => "ARB_vertex_program",
+ "ColorSubTableEXT" => "EXT_color_subtable",
+ "DeleteProgramsARB" => "ARB_vertex_program",
+ "GenProgramsARB" => "ARB_vertex_program",
+ "GetProgramEnvParameterdvARB" => "ARB_vertex_program",
+ "GetProgramEnvParameterfvARB" => "ARB_vertex_program",
+ "GetProgramLocalParameterdvARB" => "ARB_vertex_program",
+ "GetProgramLocalParameterfvARB" => "ARB_vertex_program",
+ "GetProgramStringARB" => "ARB_vertex_program",
+ "GetProgramivARB" => "ARB_vertex_program",
+ "IsProgramARB" => "ARB_vertex_program",
+ "ProgramEnvParameter4dARB" => "ARB_vertex_program",
+ "ProgramEnvParameter4dvARB" => "ARB_vertex_program",
+ "ProgramEnvParameter4fARB" => "ARB_vertex_program",
+ "ProgramEnvParameter4fvARB" => "ARB_vertex_program",
+ "ProgramLocalParameter4dARB" => "ARB_vertex_program",
+ "ProgramLocalParameter4dvARB" => "ARB_vertex_program",
+ "ProgramLocalParameter4fARB" => "ARB_vertex_program",
+ "ProgramLocalParameter4fvARB" => "ARB_vertex_program",
+ "ProgramStringARB" => "ARB_vertex_program",
+ "glXCreateContextAttribsARB" => "ARB_create_context_profile",
+ "wglCreateContextAttribsARB" => "WGL_ARB_create_context_profile",
+);
+
+my %regex = (
+ eofnc => qr/(?:\);?$|^$)/, # )$ | );$ | ^$
+ extname => qr/^[A-Z][A-Za-z0-9_]+$/,
+ none => qr/^\(none\)$/,
+ function => qr/^(.+) ([a-z][a-z0-9_]*) \((.+)\)$/i,
+ prefix => qr/^(?:[aw]?gl|glX)/, # gl | agl | wgl | glX
+ tprefix => qr/^(?:[AW]?GL|GLX)_/, # GL_ | AGL_ | WGL_ | GLX_
+ section => compile_regex('^(', join('|', @sections), ')$'), # sections in spec
+ token => qr/^([A-Z0-9][A-Z0-9_x]*):?\s+((?:0x)?[0-9A-F]+)([^\?]*)$/, # define tokens
+ types => compile_regex('\b(', join('|', keys %typemap), ')\b'), # var types
+ voidtype => compile_regex('\b(', keys %voidtypemap, ')\b '), # void type
+);
+
+# reshapes the the function declaration from multiline to single line form
+sub normalize_prototype
+{
+ local $_ = join(" ", @_);
+ s/\s+/ /g; # multiple whitespace -> single space
+ s/\<.*\>//g; # remove <comments> from direct state access extension
+ s/\<.*$//g; # remove incomplete <comments> from direct state access extension
+ s#/\*.*\*/##g; # remove /* ... */ comments
+ s/\s*\(\s*/ \(/; # exactly one space before ( and none after
+ s/\s*\)\s*/\)/; # no space before or after )
+ s/\s*\*([a-zA-Z])/\* $1/; # "* identifier"
+ s/\*wgl/\* wgl/; # "* wgl"
+ s/\*glX/\* glX/; # "* glX"
+ s/\.\.\./void/; # ... -> void
+ s/;$//; # remove ; at the end of the line
+ return $_;
+}
+
+# Ugly hack to work arround the fact that functions are declared in more
+# than one spec file.
+sub ignore_function($$)
+{
+ return exists($fnc_ignore_list{$_[0]}) && $fnc_ignore_list{$_[0]} ne $_[1]
+}
+
+sub parse_spec($)
+{
+ my $filename = shift;
+ my $extname = "";
+ my $vendortag = "";
+ my @extnames = ();
+ my %functions = ();
+ my %tokens = ();
+
+ my $section = "";
+ my @fnc = ();
+
+ my %proc = (
+ "Name" => sub {
+ if (/^([a-z0-9]+)_([a-z0-9_]+)/i)
+ {
+ $extname = "$1_$2";
+ $vendortag = $1;
+ }
+ },
+
+ "Name Strings" => sub {
+ # Add extension name to extension list
+
+ # Initially use $extname if (none) specified
+ if (/$regex{none}/)
+ {
+ $_ = $extname;
+ }
+
+ if (/$regex{extname}/)
+ {
+ # prefix with "GL_" if prefix not present
+ s/^/GL_/ unless /$regex{tprefix}/o;
+ # Add extension name to extension list
+ push @extnames, $_;
+ }
+ },
+
+ "New Procedures and Functions" => sub {
+ # if line matches end of function
+ if (/$regex{eofnc}/)
+ {
+ # add line to function declaration
+ push @fnc, $_;
+
+ # if normalized version of function looks like a function
+ if (normalize_prototype(@fnc) =~ /$regex{function}/)
+ {
+ # get return type, name, and arguments from regex
+ my ($return, $name, $parms) = ($1, $2, $3);
+ if (!ignore_function($name, $extname))
+ {
+ # prefix with "gl" if prefix not present
+ $name =~ s/^/gl/ unless $name =~ /$regex{prefix}/;
+ # is this a pure GL function?
+ if ($name =~ /^gl/ && $name !~ /^glX/)
+ {
+ # apply typemaps
+ $return =~ s/$regex{types}/$typemap{$1}/og;
+ $return =~ s/GLvoid/void/og;
+ $return =~ s/void\*/void */og;
+ $parms =~ s/$regex{types}/$typemap{$1}/og;
+ $parms =~ s/$regex{voidtype}/$voidtypemap{$1}/og;
+ $parms =~ s/GLvoid/void/og;
+ $parms =~ s/ void\* / void */og;
+ }
+ # add to functions hash
+ $functions{$name} = {
+ rtype => $return,
+ parms => $parms,
+ };
+ }
+ }
+ # reset function declaration
+ @fnc = ();
+ } elsif ($_ ne "" and $_ ne "None") {
+ # if not eof, add line to function declaration
+ push @fnc, $_
+ }
+ },
+
+ "New Tokens" => sub {
+ if (/$regex{token}/)
+ {
+ my ($name, $value) = ($1, $2);
+ # prefix with "GL_" if prefix not present
+ $name =~ s/^/GL_/ unless $name =~ /$regex{tprefix}/;
+ # Add (name, value) pair to tokens hash, unless it's taboo
+ $tokens{$name} = $value unless exists $taboo_tokens{$name};
+ }
+ },
+ );
+
+ # Some people can't read, the template clearly says "Name String_s_"
+ $proc{"Name String"} = $proc{"Name Strings"};
+
+ # Open spec file
+ open SPEC, "<$filename" or return;
+
+ # For each line of SPEC
+ while(<SPEC>)
+ {
+ # Delete trailing newline character
+ chomp;
+ # Remove trailing white spaces
+ s/\s+$//;
+ # If starts with a capital letter, it must be a new section
+ if (/^[A-Z]/)
+ {
+ # Match section name with one of the predefined names
+ $section = /$regex{section}/o ? $1 : "default";
+ } else {
+ # Line is internal to a section
+ # Remove leading whitespace
+ s/^\s+//;
+ # Call appropriate section processing function if it exists
+ &{$proc{$section}} if exists $proc{$section};
+ }
+ }
+
+ close SPEC;
+
+ return ($extname, \@extnames, \%tokens, \%functions);
+}
+
+#----------------------------------------------------------------------------------------
+
+my @speclist = ();
+my %extensions = ();
+
+my $ext_dir = shift;
+my $reg_http = "http://www.opengl.org/registry/specs/";
+
+# Take command line arguments or read list from file
+if (@ARGV)
+{
+ @speclist = @ARGV;
+} else {
+ local $/; #???
+ @speclist = split "\n", (<>);
+}
+
+foreach my $spec (sort @speclist)
+{
+ my ($extname, $extnames, $tokens, $functions) = parse_spec($spec);
+
+ foreach my $ext (@{$extnames})
+ {
+ my $info = "$ext_dir/" . $ext;
+ open EXT, ">$info";
+ print EXT $ext . "\n"; # Extension name
+ my $specname = $spec;
+ $specname =~ s/registry\/gl\/specs\///;
+ print EXT $reg_http . $specname . "\n"; # Extension info URL
+ print EXT $ext . "\n"; # Extension string
+
+ my $prefix = $ext;
+ $prefix =~ s/^(.+?)(_.+)$/$1/;
+ foreach my $token (sort {
+ if (${$tokens}{$a} eq ${$tokens}{$b}) {
+ $a cmp $b
+ } else {
+ if (${$tokens}{$a} =~ /_/) {
+ if (${$tokens}{$b} =~ /_/) {
+ $a cmp $b
+ } else {
+ -1
+ }
+ } else {
+ if (${$tokens}{$b} =~ /_/) {
+ 1
+ } else {
+ if (hex ${$tokens}{$a} eq hex ${$tokens}{$b})
+ {
+ $a cmp $b
+ } else {
+ hex ${$tokens}{$a} <=> hex ${$tokens}{$b}
+ }
+ }
+ }
+ }
+ } keys %{$tokens})
+ {
+ if ($token =~ /^$prefix\_.*/i)
+ {
+ print EXT "\t" . $token . " " . ${\%{$tokens}}{$token} . "\n";
+ }
+ }
+ foreach my $function (sort keys %{$functions})
+ {
+ if ($function =~ /^$prefix.*/i)
+ {
+ print EXT "\t" . ${$functions}{$function}{rtype} . " " . $function . " (" . ${$functions}{$function}{parms} . ")" . "\n";
+ }
+ }
+ close EXT;
+ }
+}
diff --git a/auto/bin/update_ext.sh b/auto/bin/update_ext.sh
new file mode 100755
index 0000000..e990a21
--- /dev/null
+++ b/auto/bin/update_ext.sh
@@ -0,0 +1,25 @@
+#!/bin/bash
+##
+## Copyright (C) 2002-2008, Marcelo E. Magallon <mmagallo[]debian org>
+## Copyright (C) 2002-2008, Milan Ikits <milan ikits[]ieee org>
+##
+## This program is distributed under the terms and conditions of the GNU
+## General Public License Version 2 as published by the Free Software
+## Foundation or, at your option, any later version.
+##
+## Parameters:
+##
+## $1: Extensions directory
+## $2: Registry directory
+## $3: The black list
+
+set -e
+
+if [ ! -d $1 ] ; then
+ mkdir -p $1
+
+# Parse each of the extensions in the registry
+ find $2 -name doc -type d -prune -o -name "*.txt" -print | \
+ grep -v -f $3 | sort | bin/parse_spec.pl $1
+
+fi